
package de.csw.ludum.dare.ld23;

import java.applet.Applet;
import java.awt.BorderLayout;

import de.csw.ludum.dare.ld23.sound.SoundEngine;

/**
 * @author Canard Sauvage
 * 
 *         Maybe use JNLP
 * 
 *         SEE:
 *         http://docs.oracle.com/javase/tutorial/deployment/applet/param.html
 * 
 */
public class GameApplet extends Applet {

  private static final long serialVersionUID = 1L;

  private GameComponent     game             = GameComponent.getInstance();

  @Override
  public void init() {

    setLayout(new BorderLayout());
    //
    //    setSize(4 * 320, 4 * 180);
    //
    //    setBackground(Color.GREEN);

    add(game, BorderLayout.CENTER);
  }

  @Override
  public void start() {
    game.start();
  }

  @Override
  public void stop() {
    SoundEngine.getInstance().init();
    game.stop();
  }

  //  init() – wird genau einmal aufgerufen, wenn das Applet erstmals in den Browser geladen wird.
  //  start() – wird jedes Mal aufgerufen, wenn das Applet sichtbar wird.
  //  paint(…) – Zeichenmethode für die Anzeigefunktionen des Applet
  //  stop() – wird jedes Mal aufgerufen, wenn das Applet verdeckt wird, z. B. weil das Browser-Fenster von einem anderen Fenster überdeckt wird.
  //  destroy() – wird aufgerufen, wenn das Applet aus dem Hauptspeicher entladen wird.
}
