
package de.csw.ludum.dare.ld23;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferInt;

import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.util.BitmapFill;
import de.csw.ludum.dare.ld23.util.CheapColor;

// Class representing the Screen the Player sees with a DoubleBuffer
public class GameScreen extends Bitmap {

  // 320 x 180
  // 960 x 540

  public BufferedImage bufferedImage;

  //public Bitmap        scaledBitmap;

  public GameScreen() {
    super(GameComponent.GAME_SCALED_WIDTH, GameComponent.GAME_SCALED_HEIGHT);

    //scaledBitmap = new Bitmap(GameComponent.GAME_SCALED_WIDTH, GameComponent.GAME_SCALED_HEIGHT);

    bufferedImage = new BufferedImage(GameComponent.GAME_SCALED_WIDTH, GameComponent.GAME_SCALED_HEIGHT, BufferedImage.TYPE_INT_ARGB);
    pixels = ((DataBufferInt) bufferedImage.getRaster().getDataBuffer()).getData();
  }

  public void clear() {
    BitmapFill.fillRectangle(this, 0, 0, width, height, CheapColor.BLACK);
  }

  //  private void scaleScreen() {
  //
  //    Bitmap resizedBitmap = BitmapTransform.resize(this, GameComponent.SCALE);
  //
  //    if (GameOptions.IS_EFFECT_ACTIVE) {
  //
  //      //darkenLines(resizedBitmap);
  //
  //      darkenBottomHalfOfPixels(resizedBitmap, GameComponent.GAME_SMALL_WIDTH, GameComponent.GAME_SMALL_HEIGHT);
  //
  //      darkenColumns(resizedBitmap, GameComponent.GAME_SMALL_WIDTH, GameComponent.GAME_SMALL_HEIGHT);
  //
  //      randomDarkenPixels(resizedBitmap);
  //    }
  //
  //    //scaledBitmap.blit(bitmap, 0, 0);
  //
  //    //scaledBitmap.unsafeBlockCopy(0, resizedBitmap.pixels, 0, resizedBitmap.pixels.length);
  //    scaledBitmap.unsafeBlockCopy(0, resizedBitmap.pixels, 0, resizedBitmap.pixels.length);
  //  }
  //
  //  private void randomDarkenPixels(Bitmap resizedBitmap) {
  //    for (int i = 0; i < resizedBitmap.pixels.length; i++) {
  //      resizedBitmap.pixels[i] = PixelOps.randomDarkenPixels(resizedBitmap.pixels[i]);
  //    }
  //
  //  }
  //
  //  private void darkenBottomHalfOfPixels(Bitmap resizedBitmap, int gameSmallWidth, int gameSmallHeight) {
  //
  //    int numberOfLines = GameComponent.GAME_SMALL_HEIGHT;
  //
  //    int countPixelPerDarken = GameComponent.GAME_SCALED_WIDTH * (GameComponent.SCALE / 2);
  //
  //    for (int line = 0; line < numberOfLines; line++) {
  //      for (int i = 0; i < countPixelPerDarken; i++) {
  //        int pixelIndex = countPixelPerDarken + i + (line * GameComponent.GAME_SCALED_WIDTH * GameComponent.SCALE);
  //        resizedBitmap.pixels[pixelIndex] = PixelOps.medianHardenPixel(resizedBitmap.pixels[pixelIndex]);
  //      }
  //    }
  //
  //  }
  //
  //  private void darkenColumns(Bitmap scaledBitmap, int normalWidth, int normalHeight) {
  //
  //    int numberOfLines = scaledBitmap.height;
  //    // for each line
  //    for (int line = 0; line < numberOfLines; line++) {
  //      // for each pixelX of line
  //      for (int pixelX = 0; pixelX < scaledBitmap.width; pixelX += 2 * GameComponent.SCALE) {
  //        for (int i = 0; i < GameComponent.SCALE; i++) {
  //          int pixelIndex = (line * scaledBitmap.width) + pixelX + i;
  //          scaledBitmap.pixels[pixelIndex] = PixelOps.softMedianDarkenPixel(scaledBitmap.pixels[pixelIndex]);
  //        }
  //      }
  //    }
  //  }

  public void drawScreen(Canvas canvas, Graphics g) {
    g.setColor(Color.BLACK);
    g.fillRect(0, 0, canvas.getWidth(), canvas.getHeight());
    g.translate((canvas.getWidth() - GameComponent.GAME_SCALED_WIDTH) / 2, (canvas.getHeight() - GameComponent.GAME_SCALED_HEIGHT) / 2);
    g.clipRect(0, 0, GameComponent.GAME_SCALED_WIDTH, GameComponent.GAME_SCALED_HEIGHT);

    // scaleScreen();

    g.drawImage(bufferedImage, 0, 0, GameComponent.GAME_SCALED_WIDTH, GameComponent.GAME_SCALED_HEIGHT, null);
  }
}
