
package de.csw.ludum.dare.ld23.control;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.HashMap;
import java.util.Map;

public class InputHandler implements KeyListener {

  private Map<Integer, InputKey> mappings = new HashMap<Integer, InputKey>();

  public InputHandler() {
    mappings.put(KeyEvent.VK_UP, InputKey.UP);
    mappings.put(KeyEvent.VK_DOWN, InputKey.DOWN);
    mappings.put(KeyEvent.VK_LEFT, InputKey.LEFT);
    mappings.put(KeyEvent.VK_RIGHT, InputKey.RIGHT);
    mappings.put(KeyEvent.VK_ENTER, InputKey.ENTER);
    mappings.put(KeyEvent.VK_F11, InputKey.SOUND);
    //
    //    mappings.put(KeyEvent.VK_NUMPAD8, keys.up);
    //    mappings.put(KeyEvent.VK_NUMPAD2, keys.down);
    //    mappings.put(KeyEvent.VK_NUMPAD4, keys.left);
    //    mappings.put(KeyEvent.VK_NUMPAD6, keys.right);
    //
    //    mappings.put(KeyEvent.VK_W, keys.up);
    //    mappings.put(KeyEvent.VK_S, keys.down);
    //    mappings.put(KeyEvent.VK_A, keys.left);
    //    mappings.put(KeyEvent.VK_D, keys.right);
    //
    //    mappings.put(KeyEvent.VK_SPACE, keys.fire);
    //    mappings.put(KeyEvent.VK_ALT, keys.fire);
    //    mappings.put(KeyEvent.VK_CONTROL, keys.fire);
    //    mappings.put(KeyEvent.VK_SHIFT, keys.fire);
    //    mappings.put(KeyEvent.VK_C, keys.fire);
    //
    //    mappings.put(KeyEvent.VK_X, keys.build);
    //    mappings.put(KeyEvent.VK_Z, keys.use);
    //    mappings.put(KeyEvent.VK_R, keys.build);
    //    mappings.put(KeyEvent.VK_E, keys.use);
  }

  @Override
  public void keyPressed(KeyEvent ke) {
    toggle(ke, true);
  }

  @Override
  public void keyReleased(KeyEvent ke) {
    toggle(ke, false);
  }

  @Override
  public void keyTyped(KeyEvent ke) {
  }

  public void tick() {
    for (InputKey key : InputKey.values()) {
      key.tick();
    }
  }

  private void toggle(KeyEvent ke, boolean state) {
    InputKey key = mappings.get(ke.getKeyCode());
    if (key != null) {
      key.nextState = state;
    }
  }
}
