
package de.csw.ludum.dare.ld23.control;

public enum InputKey {
  ENTER,
  UP,
  DOWN,
  LEFT,
  RIGHT,
  SOUND;

  /**
   * State = isDown
   */
  public boolean nextState = false;
  public boolean wasDown   = false;
  public boolean isDown    = false;

  public static void tickAllKeys() {
    for (InputKey inputKey : InputKey.values()) {
      inputKey.tick();
    }
  }

  public void tick() {
    wasDown = isDown;
    isDown = nextState;
  }

  public boolean wasPressed() {
    return !wasDown && isDown;
  }

  public boolean wasReleased() {
    return wasDown && !isDown;
  }

  public void release() {
    nextState = false;
  }

}
