
package de.csw.ludum.dare.ld23.graphic;

import java.awt.image.BufferedImage;

public class Bitmap {

  public int   width;

  public int   height;

  public int[] pixels;

  public static Bitmap copyOf(Bitmap bitmap) {
    return new Bitmap(bitmap);
  }

  private Bitmap(Bitmap bitmapDirect) {
    width = bitmapDirect.width;
    height = bitmapDirect.height;
    pixels = bitmapDirect.pixels.clone();
  }

  public Bitmap(int width, int height) {
    this.width = width;
    this.height = height;
    pixels = new int[width * height];
  }

  public Bitmap(BufferedImage loadedImage) {
    this(loadedImage.getWidth(), loadedImage.getHeight());

    loadPixelFromBufferedImage(loadedImage);
  }

  public Bitmap(int width, int height, int[] resize) {
    this.width = width;
    this.height = height;
    pixels = resize;
  }

  private void loadPixelFromBufferedImage(BufferedImage loadedImage) {
    loadedImage.getRGB(0, 0, width, height, pixels, 0, width);
  }

  public void blit(Bitmap sourceBitmap, int x, int y) {
    int x0 = x;
    int x1 = x + sourceBitmap.width;
    int y0 = y;
    int y1 = y + sourceBitmap.height;
    if (x0 < 0) {
      x0 = 0;
    }
    if (y0 < 0) {
      y0 = 0;
    }
    if (x1 > width) {
      x1 = width;
    }
    if (y1 > height) {
      y1 = height;
    }
    int ww = x1 - x0;

    for (int yy = y0; yy < y1; yy++) {
      int tp = yy * width + x0;
      int sp = (yy - y) * sourceBitmap.width + (x0 - x);
      tp -= sp;
      for (int xx = sp; xx < sp + ww; xx++) {
        int col = sourceBitmap.pixels[xx];
        if (col < 0) {
          pixels[tp + xx] = col;
        }
      }
    }
  }

  public void alphaBlit(Bitmap sourceBitmap, int x, int y) {

  }

  // System.arraycopy(Object src, int srcPos, Object dest, int destPos, int length) 
  public void unsafeBlockCopy(int srcOffsetBytes, int[] sourcePixels, int dstOffset, int count) {
    System.arraycopy(sourcePixels, srcOffsetBytes, pixels, dstOffset, count);
    //    for (int i = 0; i < count; i++) {
    //      pixels[i + dstOffset] = sourcePixels[i + srcOffsetBytes];
    //    }
  }

}
