
package de.csw.ludum.dare.ld23.graphic;

public class Sprite {

  public final Bitmap[][] result;

  public final int        lines;

  public final int        columms;

  private int             currentLine = 0;

  private int             currentCol  = 0;

  public int              spriteCount = 1;

  public final int        ticksPerAnim;

  public Sprite(Bitmap[][] result, int ticksPerAnim) {
    this.result = result;
    this.ticksPerAnim = ticksPerAnim;
    columms = result.length;
    lines = result[0].length;
  }

  public void moveRight() {
    currentCol = 0;
    spriteCount++;
  }

  public void moveLeft() {
    currentCol = 1;
    spriteCount++;
  }

  public void checkSpriteCount() {
    if (spriteCount % ticksPerAnim == 0) {
      spriteCount++;
      if (currentLine == 0) {
        currentLine = 1;
      } else {
        currentLine = 0;
      }
    }
  }

  public Bitmap currentMovingSprite() {
    return getBitmapDirect(currentCol, currentLine);
  }

  public Bitmap getBitmapDirect(int column, int line) {
    return result[column][line];
  }

  public Bitmap getBitmapDirect(int nr) {
    int line = nr / 4;
    int column = nr % 4;
    return result[column][line];
  }

  public static void main(String[] args) {
    int nr = 6;

    int line = nr / 4;
    int column = nr % 4;

    System.out.println("Line: " + line);
    System.out.println("Col: " + column);
  }

  public static Sprite copyOf(Sprite staticsprite) {
    return new Sprite(staticsprite.result, staticsprite.ticksPerAnim);
  }
}
