
package de.csw.ludum.dare.ld23.graphic;

import java.awt.Rectangle;

import de.csw.ludum.dare.ld23.util.BitmapTransform;

public class Tile {

  private final boolean   walkable;

  private final Character c;

  public final Rectangle  rectangle;

  public final Bitmap     bitmap;

  public Tile(Bitmap bitmapDirect, boolean walkable, char c, Rectangle rectangle, int scale) {
    Bitmap unscaledbitmap = Bitmap.copyOf(bitmapDirect);
    BitmapTransform.randomPixelColors(unscaledbitmap);
    bitmap = BitmapTransform.editAndScaleBitmap(unscaledbitmap, scale);

    this.walkable = walkable;
    this.c = c;
    this.rectangle = rectangle;
  }

  public boolean isWalkable() {
    return walkable;
  }

  @Override
  public String toString() {
    return "Tile [walkable=" + walkable + ", c=" + c + "]";
  }

  public boolean isIntersecting(Rectangle newBoundaryRectangle) {
    return rectangle.intersects(newBoundaryRectangle);
  }
}
