
package de.csw.ludum.dare.ld23.graphic.fonts;

import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.Sprite;

public class BitmapFont {

  public static String letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-.!?/%$\\=*+,;:()&#\"' ";

  public static Sprite font    = ImageLoader.loadSprite("/fonts/font1.png", 8, 8);

  public static void main(String[] args) {
    System.out.println(letters.length());
  }

  public static int getStringWidth(String s) {
    return s.length() * 8;
  }

  private BitmapFont() {
  }

  public static void draw(Bitmap screen, String msg, int x, int y) {
    msg = msg.toUpperCase();
    int length = msg.length();
    for (int i = 0; i < length; i++) {
      int c = letters.indexOf(msg.charAt(i));
      if (c < 0) {
        continue;
      }
      screen.blit(font.getBitmapDirect(c, 0), x, y);
      x += 8;
    }
  }
}
