
package de.csw.ludum.dare.ld23.graphic.fonts;

import de.csw.ludum.dare.ld23.GameComponent;
import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.Sprite;

public class BitmapFont3 {

  public static final int LETTER_WIDTH        = 16;

  public static final int SCALED_LETTER_WIDTH = 16 * GameComponent.SCALE;

  public static String    letters             = "ABCDEFGHIJKLMNOPQRSTUVWXYZ.0123456789:<> ";

  public static Sprite    font                = ImageLoader.loadSprite("/fonts/font3.png", LETTER_WIDTH, 22);

  public static void main(String[] args) {
    System.out.println(letters.length());
  }

  private BitmapFont3() {
  }

  public static void draw(Bitmap screen, String msg, int x, int y) {
    msg = msg.toUpperCase();
    int length = msg.length();
    for (int i = 0; i < length; i++) {
      int c = letters.indexOf(msg.charAt(i));
      if (c < 0) {
        continue;
      }
      screen.blit(font.getBitmapDirect(c, 0), x, y);
      x += 24;
    }
  }
}
