
package de.csw.ludum.dare.ld23.graphic.ui;

import de.csw.ludum.dare.ld23.GameComponent;
import de.csw.ludum.dare.ld23.GameOptions;
import de.csw.ludum.dare.ld23.GameScreen;
import de.csw.ludum.dare.ld23.control.InputKey;
import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.objects.Renderable;

public class End implements Renderable {

  private final Bitmap bitmap;

  private boolean      isEnterPushed       = false;

  private long         tickCountSinceEnter = 0;

  public End() {
    bitmap = ImageLoader.loadScaledBitmap("/ui/end.png");
  }

  @Override
  public void renderMe(GameScreen screen) {
    screen.blit(bitmap, 0, 0);
  }

  public void tick() {
    if (InputKey.ENTER.isDown) {
      isEnterPushed |= true;
    }
    if (isEnterPushed) {
      tickCountSinceEnter++;
      if (tickCountSinceEnter % 30 == 0) {
        System.out.println("Restart");
        GameOptions.showEnd = false;
        GameComponent.restart();
      }
    }
  }
}
