
package de.csw.ludum.dare.ld23.graphic.ui;

import de.csw.ludum.dare.ld23.GameScreen;
import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.objects.Hero;
import de.csw.ludum.dare.ld23.level.Level;

public class HealthBar {

  private final Bitmap emptyHeart;

  private final Bitmap halfHeart;

  private final Bitmap fullHeart;

  public HealthBar() {
    emptyHeart = ImageLoader.loadScaledBitmap("/ui/heart_empty.png");
    halfHeart = ImageLoader.loadScaledBitmap("/ui/heart_half.png");
    fullHeart = ImageLoader.loadScaledBitmap("/ui/heart_full.png");
  }

  public void renderMe(GameScreen screen, Level level, Hero hero) {

    int numberOfHearts = hero.heroTier.maxHealth / 2;
    int drawnHearts = 0;
    int offsetX = 8;

    int fullHears = hero.health / 2;
    int halfHearts = hero.health % 2;

    for (int i = 0; i < fullHears; i++) {
      screen.blit(fullHeart, offsetX, 462);
      offsetX += 54;
      drawnHearts++;
    }
    for (int i = 0; i < halfHearts; i++) {
      screen.blit(halfHeart, offsetX, 462);
      offsetX += 54;
      drawnHearts++;
    }
    for (int i = 0; i < (numberOfHearts - drawnHearts); i++) {
      screen.blit(emptyHeart, offsetX, 462);
      offsetX += 54;
    }
  }
}
