
package de.csw.ludum.dare.ld23.graphic.ui;

import de.csw.ludum.dare.ld23.GameScreen;
import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.objects.Hero;
import de.csw.ludum.dare.ld23.level.Level;

public class HungerBar {

  private final Bitmap empty;

  private final Bitmap full;

  public HungerBar() {
    empty = ImageLoader.loadScaledBitmap("/ui/hunger_empty.png");
    full = ImageLoader.loadScaledBitmap("/ui/hunger_full.png");
  }

  public void renderMe(GameScreen screen, Level level, Hero hero) {

    int offsetX = 8;

    int nrOfBars = 10;

    int fullBars = 0;
    if (hero.enemiesByHungerEaten != 0) {
      fullBars = (int) (((1.0f * hero.enemiesByHungerEaten) / hero.heroTier.maxEatToGrow) * nrOfBars);
    }
    int emptyBars = nrOfBars - fullBars;

    for (int i = 0; i < fullBars; i++) {
      screen.blit(full, offsetX, 510);
      offsetX += 56;
    }
    for (int i = 0; i < emptyBars; i++) {
      screen.blit(empty, offsetX, 510);
      offsetX += 56;
    }
  }
}
