
package de.csw.ludum.dare.ld23.graphic.ui;

import java.util.concurrent.atomic.AtomicInteger;

import de.csw.ludum.dare.ld23.GameOptions;
import de.csw.ludum.dare.ld23.GameScreen;
import de.csw.ludum.dare.ld23.control.InputKey;
import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.fonts.BitmapFont2;
import de.csw.ludum.dare.ld23.graphic.fonts.BitmapFont3;
import de.csw.ludum.dare.ld23.graphic.objects.Renderable;

public class Splash implements Renderable {

  private final Bitmap  bitmap;

  private boolean       isEnterPushed = false;

  private int           tickCount;

  private final Title   title;

  private AtomicInteger offsetX       = new AtomicInteger(1100);

  private String        movingString  = "PRESS F11 TO MUTE > EAT.  GROW.  EAT STRONGER ENEMIES.  I  YOU ARE A GIANT RAT FROM SPACE. STRANDED ON A TINY PLANET. IF YOU GROW YOUR MOTHERSHIP WILL SEE YOU FROM SPACE.";

  public Splash() {
    bitmap = ImageLoader.loadBitmap("/splash/splash.png");
    title = new Title();
  }

  @Override
  public void renderMe(GameScreen screen) {
    BitmapFont2.draw(screen, "PRESS ENTER", 330, 460);

    int offsetXToBlit = offsetX.get();
    for (int i = 0; i < movingString.length(); i++) {
      char c = movingString.charAt(i);
      BitmapFont3.draw(screen, String.valueOf(c), offsetXToBlit + (i * BitmapFont3.LETTER_WIDTH), 510);
    }

    screen.blit(bitmap, 0, 0);
    title.renderMe(screen);
  }

  public void tick() {

    tickCount++;
    if (InputKey.ENTER.isDown) {
      isEnterPushed |= true;
      GameOptions.showSplash = false;
    }
    //    if (isEnterPushed) {
    //      tickCountSinceEnter++;
    //    }
    offsetX.decrementAndGet();
    if (offsetX.get() < -2300) {
      offsetX.set(1300);
    }

    title.tick();
  }
}
