
package de.csw.ludum.dare.ld23.graphic.ui;

import de.csw.ludum.dare.ld23.GameScreen;
import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.Sprite;

public class Title {

  private static final int FRAME_COUNT  = 5;

  private final Sprite     sprite;

  private int              blitToX      = 16;

  private int              blitToY      = 200;

  private long             tickCount    = 0;

  private int              currentFrame = 0;

  public Title() {
    sprite = ImageLoader.loadScaledSprite("/splash/title.png", 465, 112, 2);
  }

  public void renderMe(GameScreen screen) {
    screen.blit(getCurrentBitmapFrame(), blitToX, blitToY);
  }

  public void tick() {
    tickCount++;
    if (tickCount % 10 == 0) {
      increaseFrame();
    }
  }

  private void increaseFrame() {
    currentFrame++;
    if (currentFrame >= FRAME_COUNT) {
      currentFrame = 0;
    }
  }

  private Bitmap getCurrentBitmapFrame() {
    return sprite.getBitmapDirect(0, currentFrame);
  }
}
