
package de.csw.ludum.dare.ld23.graphic.ui;

import de.csw.ludum.dare.ld23.GameComponent;
import de.csw.ludum.dare.ld23.GameOptions;
import de.csw.ludum.dare.ld23.GameScreen;
import de.csw.ludum.dare.ld23.control.InputKey;
import de.csw.ludum.dare.ld23.graphic.Bitmap;
import de.csw.ludum.dare.ld23.graphic.ImageLoader;
import de.csw.ludum.dare.ld23.graphic.fonts.BitmapFont3;
import de.csw.ludum.dare.ld23.graphic.objects.Renderable;
import de.csw.ludum.dare.ld23.util.BitmapLine;

public class Win implements Renderable {

  private final Bitmap bitmap;

  private boolean      isEnterPushed       = false;

  private long         tickCountSinceEnter = 0;

  private int          offsetX             = 1000;

  private String       movingString        = "YOU WIN. THE RAT IS NOW REALLY GIGANTIC AND HAS EATEN EVERYTHING ON THE WORLD. YOUR MOTHERSHIP WILL NOW SEE YOU FROM SPACE.";

  public Win() {
    bitmap = ImageLoader.loadScaledBitmap("/ui/win.png");
  }

  @Override
  public void renderMe(GameScreen screen) {

    for (int i = 0; i < 28; i++) {
      BitmapLine.drawLineDDA(screen, 0, 508 + i, GameComponent.GAME_SCALED_WIDTH, 508 + i, 0xFF000000);
    }

    int offsetXToBlit = offsetX;
    for (int i = 0; i < movingString.length(); i++) {
      char c = movingString.charAt(i);
      BitmapFont3.draw(screen, String.valueOf(c), offsetXToBlit + (i * BitmapFont3.LETTER_WIDTH), 510);
    }
    screen.blit(bitmap, 0, 0);
  }

  public void tick() {

    offsetX--;
    if (offsetX < -2000) {
      offsetX = 1000;
    }

    if (InputKey.ENTER.isDown) {
      isEnterPushed |= true;
    }
    if (isEnterPushed) {
      tickCountSinceEnter++;
      if (tickCountSinceEnter % 30 == 0) {
        System.out.println("Restart");
        GameOptions.showEnd = false;
        GameComponent.restart();
      }
    }
  }
}
