
package de.csw.ludum.dare.ld23.util;

import java.util.Random;

import de.csw.ludum.dare.ld23.graphic.Bitmap;

public class PixelOps {

  //  public static int hardDarkenPixel(int pixel) {
  //    return darkenPixel(pixel, 15);
  //  }
  //
  //  public static int softDarkenPixel(int pixel) {
  //    return darkenPixel(pixel, 7);
  //  }

  public static final Random RANDOM = new Random();

  public static void main(String[] args) {

    int pixel = 0xFF312B2B;
    int a = (pixel >>> 24) & 0x000000FF;
    int r = (pixel >>> 16) & 0x000000FF;
    int g = (pixel >>> 8) & 0x000000FF;
    int b = (pixel) & 0x000000FF;

    int stdSubstractValue = 8 + (int) ((Math.pow((r + g + b), 2) / Math.pow(2, 15)));
    System.out.println(stdSubstractValue);
  }

  public static int softMedianDarkenPixel(int pixel) {
    int a = (pixel >>> 24) & 0x000000FF;
    int r = (pixel >>> 16) & 0x000000FF;
    int g = (pixel >>> 8) & 0x000000FF;
    int b = (pixel) & 0x000000FF;

    int colorSum = (r + g + b);

    int stdSubstractValue = 4 + (int) ((Math.pow(colorSum, 2) / TWO_POW_15));
    if (colorSum >= 690) {
      stdSubstractValue = 6;
    }

    r = darkenColorTone(r, stdSubstractValue);
    g = darkenColorTone(g, stdSubstractValue);
    b = darkenColorTone(b, stdSubstractValue);

    return CheapColor.colorOfARGB(a, r, g, b);
  }

  public static final int TWO_POW_15 = (int) Math.pow(2, 15);

  public static int medianHardenPixel(int pixel) {

    int a = (pixel >>> 24) & 0x000000FF;
    int r = (pixel >>> 16) & 0x000000FF;
    int g = (pixel >>> 8) & 0x000000FF;
    int b = (pixel) & 0x000000FF;

    int colorSum = (r + g + b);

    int stdSubstractValue = 7 + (int) ((Math.pow(colorSum, 2) / TWO_POW_15));
    if (colorSum >= 690) {
      stdSubstractValue = 8;
    }

    r = darkenColorTone(r, stdSubstractValue);
    g = darkenColorTone(g, stdSubstractValue);
    b = darkenColorTone(b, stdSubstractValue);

    return CheapColor.colorOfARGB(a, r, g, b);
  }

  private static int darkenPixel(int pixel, int stdSubstractValue) {

    int a = (pixel >>> 24) & 0x000000FF;
    int r = (pixel >>> 16) & 0x000000FF;
    int g = (pixel >>> 8) & 0x000000FF;
    int b = (pixel) & 0x000000FF;

    int colorSum = (r + g + b);

    if (colorSum >= 690) {
      stdSubstractValue = stdSubstractValue * 2;
    }

    r = darkenColorTone(r, stdSubstractValue);
    g = darkenColorTone(g, stdSubstractValue);
    b = darkenColorTone(b, stdSubstractValue);

    return CheapColor.colorOfARGB(a, r, g, b);
  }

  public static int darkenColorTone(int colorTone, int stdSubstractValue) {
    if ((stdSubstractValue < 0) && (colorTone - stdSubstractValue < 0)) {
      return stdSubstractValue;
    }

    if (colorTone - stdSubstractValue > 255) {
      return 255;
    }

    if (colorTone > stdSubstractValue) {
      return colorTone - stdSubstractValue;
    }

    return 0;
  }

  public static void randomDarkenPixels(Bitmap resizedBitmap) {
    for (int i = 0; i < resizedBitmap.pixels.length; i++) {
      resizedBitmap.pixels[i] = PixelOps.randomDarkenPixels(resizedBitmap.pixels[i]);
    }

  }

  public static void randomDarkenMetaPixel(Bitmap resizedBitmap, int normalWidth, int normalHeight, int scale) {
    // TODO Auto-generated method stub
    if (scale == 2) {
      return;
    }
    int subpixelWidth = scale / 2;

    int rowHeightInMetaPixel = scale / subpixelWidth;

    for (int metaPixelX = 0; metaPixelX < normalWidth * rowHeightInMetaPixel; metaPixelX++) {
      for (int metaPixelY = 0; metaPixelY < normalHeight * rowHeightInMetaPixel; metaPixelY++) {

        int firstPixel = (subpixelWidth * resizedBitmap.width * metaPixelY) + (metaPixelX * subpixelWidth);

        int substractValue = RANDOM.nextInt(12) - 5;

        resizedBitmap.pixels[firstPixel] = darkenPixel(resizedBitmap.pixels[firstPixel], substractValue);
        resizedBitmap.pixels[firstPixel + 1] = darkenPixel(resizedBitmap.pixels[firstPixel], substractValue);
        resizedBitmap.pixels[firstPixel + 2] = darkenPixel(resizedBitmap.pixels[firstPixel], substractValue);

        resizedBitmap.pixels[resizedBitmap.width + firstPixel] = darkenPixel(resizedBitmap.pixels[resizedBitmap.width + firstPixel], substractValue);
        resizedBitmap.pixels[resizedBitmap.width + firstPixel + 1] = darkenPixel(resizedBitmap.pixels[resizedBitmap.width + firstPixel + 1],
            substractValue);
        resizedBitmap.pixels[resizedBitmap.width + firstPixel + 2] = darkenPixel(resizedBitmap.pixels[resizedBitmap.width + firstPixel + 2],
            substractValue);

        resizedBitmap.pixels[(2 * resizedBitmap.width) + firstPixel] = darkenPixel(resizedBitmap.pixels[(2 * resizedBitmap.width) + firstPixel],
            substractValue);
        resizedBitmap.pixels[(2 * resizedBitmap.width) + firstPixel + 1] = darkenPixel(resizedBitmap.pixels[(2 * resizedBitmap.width) + firstPixel
            + 1], substractValue);
        resizedBitmap.pixels[(2 * resizedBitmap.width) + firstPixel + 2] = darkenPixel(resizedBitmap.pixels[(2 * resizedBitmap.width) + firstPixel
            + 2], substractValue);
      }
    }

    //    int subpixelWidth = scale / 2;
    //    int substractValue = RANDOM.nextInt(7) - subpixelWidth;
    //
    //    for (int line = 0; line < normalHeight; line++) {
    //
    //      int firstPixelInMetaLine = resizedBitmap.width * (line * subpixelWidth);
    //
    //      for (int pixelX = 0; pixelX < subpixelWidth; pixelX += subpixelWidth) {
    //        int firstMetaPixel = firstPixelInMetaLine + pixelX;
    //
    //        for (int j = 0; j < subpixelWidth; j++) {
    //
    //          int pixel = firstMetaPixel + j;
    //
    //          resizedBitmap.pixels[pixel] = 0xFF000000;
    //        }
    //      }
    //
    //    }

  }

  private static int randomDarkenPixels(int pixel) {
    return darkenPixel(pixel, RANDOM.nextInt(5) - 2);
  }

  public static void darkenBottomHalfOfPixels(Bitmap resizedBitmap, int gameSmallWidth, int gameSmallHeight, int scale) {

    int numberOfLines = gameSmallHeight;

    int countPixelPerDarken = resizedBitmap.width * (scale / 2);

    for (int line = 0; line < numberOfLines; line++) {
      for (int i = 0; i < countPixelPerDarken; i++) {
        int pixelIndex = countPixelPerDarken + i + (line * resizedBitmap.width * scale);
        resizedBitmap.pixels[pixelIndex] = PixelOps.medianHardenPixel(resizedBitmap.pixels[pixelIndex]);
      }
    }

  }

  public static void darkenColumns(Bitmap scaledBitmap, int normalWidth, int normalHeight, int scale) {

    int numberOfLines = scaledBitmap.height;
    // for each line
    for (int line = 0; line < numberOfLines; line++) {
      // for each pixelX of line
      for (int pixelX = 0; pixelX < scaledBitmap.width; pixelX += 2 * scale) {
        for (int i = 0; i < scale; i++) {
          int pixelIndex = (line * scaledBitmap.width) + pixelX + i;
          scaledBitmap.pixels[pixelIndex] = PixelOps.medianHardenPixel(scaledBitmap.pixels[pixelIndex]);
        }
      }
    }
  }

}
